SystemOrganization addCategory: #'CompressionTests-Archive'!

TestCase subclass: #ZipArchiveTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CompressionTests-Archive'!

!ZipArchiveTest methodsFor: 'tests' stamp: 'GabrielBarbuto 9/27/2010 10:56'!
testCreateWithRelativeNames
	"Test creating a zip with a relative tree of files, so that the tree will
	be created whereever the ."
	| subdir zip |
	subdir := FileDirectory default / '_test-zip-dir'.
	self deny: subdir exists.
	subdir assureExistence.
	[ subdir
		fileNamed: '_test-zip-file'
		do: [ : stream | stream nextPutAll: 'file contents' ].
	zip := ZipArchive new.
	zip
		addDirectory: subdir fullName
		as: subdir localName.
	zip	
		addFile: (subdir fullNameFor: '_test-zip-file')
		as: '_test-zip-dir' , FileDirectory slash , '_test-zip-file'.
	zip writeToFileNamed: (FileDirectory default fullNameFor: '_test.zip') ] 
	ensure: [
		zip close.	
		subdir ifNotNil: [ subdir recursiveDelete ].
		FileDirectory default deleteFileNamed: '_test.zip' ]
! !

!ZipArchiveTest methodsFor: 'tests' stamp: 'StephaneDucasse 9/10/2010 18:13'!
testDate29Feb2000
	"Ensure that dates with leap years don't screw up in the conversion"

	| archive member theDate |
	theDate := Date year: 2000 month: 2 day: 29.
	archive := ZipArchive new.
	member := archive addDeflateString: 'foo' as: 'bar'.
	member setLastModFileDateTimeFrom: theDate asSeconds.
	self shouldnt: [member lastModTime] raise: Error.
	self assert: (Date fromSeconds: member lastModTime) = theDate.! !
